#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <signal.h>

struct user {
    int uid;
    char name[100];
} typedef User;

User *users[1000];

uint8_t count_u = 0;

int read_until(char *buf, char end, int max)
{
    int i;
    char c;
    int n;
    for (i = 0; i < max; i++) {
        n = read(0, &c, 1);
        if (n == -1)
            exit(0);
        else if (n == 0 || c == '\n')
            break;

        buf[i] = c;
    }
	buf[i] = 0;
    return i;
}

void regist()
{
    printf("%d\n", count_u);
    if (count_u == 1000) {
        printf("full\n");
        fflush(stdout);
        return;
    }

    User *u = (User*) calloc(sizeof(User), 1);
    printf("Input username: ");
    fflush(stdout);
    read_until(u->name, '\n', 100);
    u->uid = count_u;
    if (strcmp(u->name, "root"))
        users[count_u++] = u;
    else {
        printf("illegal username!\n");
        fflush(stdout);
        free(u);
    }
}

void login()
{
    char buf[100];
    printf("Input username: ");
    fflush(stdout);
    read_until(buf, '\n', 100);

    int i;
    for (i = 0; i < count_u; i++) {
        if (!strcmp(users[i]->name, buf))
            break;
    }

    if (i == count_u) {
        printf("User %s not found!\n", buf);
		return;
    }

    if (users[i]->uid)
        printf("Welcome %s, your are a toor user.\n", users[i]->name);
    else {
        printf("Welcome %s, your are ROOT!!!!!.\n", users[i]->name);
        system("/bin/sh");
    }
    fflush(stdout);
}

void handler()
{
	puts("Time's up!");
	exit(0);
}

int main()
{
	signal(SIGALRM, handler);
	alarm(30);
    User *u = (User*) calloc(sizeof(User), 1);
    users[count_u++] = u;
    sprintf(u->name, "%s", "root");
    u->uid = count_u;

    int c;
    char buf[10];

    while (1) {
        puts("1. register");
        puts("2. login");
        printf("> ");
        fflush(stdout);

        fgets(buf, 10, stdin);
        c = atoi(buf);
        
        switch (c) {
            case 1:
                regist();
                break;
            case 2:
                login();
                break;
            default:
                printf("Oops!\n");
                fflush(stdout);
                break;
        }
    }


    return 0; 
}
